/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the BillingAccountAssignment type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &BillingAccountAssignment{}

// BillingAccountAssignment struct for BillingAccountAssignment
type BillingAccountAssignment struct {
	AccountId string `json:"account_id"`
	Account *BillingAccount `json:"account,omitempty"`
	OrganizationId *string `json:"organization_id,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
	// true if entry is currently is in use with selected list
	Current *bool `json:"current,omitempty"`
	InteractionId *string `json:"interaction_id,omitempty"`
	// If not specified, now will be used
	StartingAt *time.Time `json:"starting_at,omitempty"`
}

// NewBillingAccountAssignment instantiates a new BillingAccountAssignment object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBillingAccountAssignment(accountId string) *BillingAccountAssignment {
	this := BillingAccountAssignment{}
	this.AccountId = accountId
	return &this
}

// NewBillingAccountAssignmentWithDefaults instantiates a new BillingAccountAssignment object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBillingAccountAssignmentWithDefaults() *BillingAccountAssignment {
	this := BillingAccountAssignment{}
	return &this
}

// GetAccountId returns the AccountId field value
func (o *BillingAccountAssignment) GetAccountId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value
// and a boolean to check if the value has been set.
func (o *BillingAccountAssignment) GetAccountIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AccountId, true
}

// SetAccountId sets field value
func (o *BillingAccountAssignment) SetAccountId(v string) {
	o.AccountId = v
}

// GetAccount returns the Account field value if set, zero value otherwise.
func (o *BillingAccountAssignment) GetAccount() BillingAccount {
	if o == nil || IsNil(o.Account) {
		var ret BillingAccount
		return ret
	}
	return *o.Account
}

// GetAccountOk returns a tuple with the Account field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccountAssignment) GetAccountOk() (*BillingAccount, bool) {
	if o == nil || IsNil(o.Account) {
		return nil, false
	}
	return o.Account, true
}

// HasAccount returns a boolean if a field has been set.
func (o *BillingAccountAssignment) HasAccount() bool {
	if o != nil && !IsNil(o.Account) {
		return true
	}

	return false
}

// SetAccount gets a reference to the given BillingAccount and assigns it to the Account field.
func (o *BillingAccountAssignment) SetAccount(v BillingAccount) {
	o.Account = &v
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *BillingAccountAssignment) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccountAssignment) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *BillingAccountAssignment) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *BillingAccountAssignment) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *BillingAccountAssignment) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccountAssignment) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *BillingAccountAssignment) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *BillingAccountAssignment) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetCurrent returns the Current field value if set, zero value otherwise.
func (o *BillingAccountAssignment) GetCurrent() bool {
	if o == nil || IsNil(o.Current) {
		var ret bool
		return ret
	}
	return *o.Current
}

// GetCurrentOk returns a tuple with the Current field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccountAssignment) GetCurrentOk() (*bool, bool) {
	if o == nil || IsNil(o.Current) {
		return nil, false
	}
	return o.Current, true
}

// HasCurrent returns a boolean if a field has been set.
func (o *BillingAccountAssignment) HasCurrent() bool {
	if o != nil && !IsNil(o.Current) {
		return true
	}

	return false
}

// SetCurrent gets a reference to the given bool and assigns it to the Current field.
func (o *BillingAccountAssignment) SetCurrent(v bool) {
	o.Current = &v
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *BillingAccountAssignment) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccountAssignment) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *BillingAccountAssignment) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *BillingAccountAssignment) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetStartingAt returns the StartingAt field value if set, zero value otherwise.
func (o *BillingAccountAssignment) GetStartingAt() time.Time {
	if o == nil || IsNil(o.StartingAt) {
		var ret time.Time
		return ret
	}
	return *o.StartingAt
}

// GetStartingAtOk returns a tuple with the StartingAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccountAssignment) GetStartingAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.StartingAt) {
		return nil, false
	}
	return o.StartingAt, true
}

// HasStartingAt returns a boolean if a field has been set.
func (o *BillingAccountAssignment) HasStartingAt() bool {
	if o != nil && !IsNil(o.StartingAt) {
		return true
	}

	return false
}

// SetStartingAt gets a reference to the given time.Time and assigns it to the StartingAt field.
func (o *BillingAccountAssignment) SetStartingAt(v time.Time) {
	o.StartingAt = &v
}

func (o BillingAccountAssignment) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o BillingAccountAssignment) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["account_id"] = o.AccountId
	if !IsNil(o.Account) {
		toSerialize["account"] = o.Account
	}
	if !IsNil(o.OrganizationId) {
		toSerialize["organization_id"] = o.OrganizationId
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.Current) {
		toSerialize["current"] = o.Current
	}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.StartingAt) {
		toSerialize["starting_at"] = o.StartingAt
	}
	return toSerialize, nil
}

type NullableBillingAccountAssignment struct {
	value *BillingAccountAssignment
	isSet bool
}

func (v NullableBillingAccountAssignment) Get() *BillingAccountAssignment {
	return v.value
}

func (v *NullableBillingAccountAssignment) Set(val *BillingAccountAssignment) {
	v.value = val
	v.isSet = true
}

func (v NullableBillingAccountAssignment) IsSet() bool {
	return v.isSet
}

func (v *NullableBillingAccountAssignment) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBillingAccountAssignment(val *BillingAccountAssignment) *NullableBillingAccountAssignment {
	return &NullableBillingAccountAssignment{value: val, isSet: true}
}

func (v NullableBillingAccountAssignment) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBillingAccountAssignment) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


